| OpendTect 8.0

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Private Member Functions | Static Private Member Functions | Friends | List of all members
visBase::RandomTrackDragger Class Reference
visBase

`#include <visrandomtrackdragger.h>`

Inheritance diagram for visBase::RandomTrackDragger:
[legend]

## Classes
struct | DragControl

## Public Member Functions
bool | areAdjacentPanelsShown (int knotidx) const
bool | areAllPanelsShown () const
const char * | getClassName () const override
Interval< float > | getDepthRange () const
const visBase::Transformation * | getDisplayTransformation () const override
Coord | getKnot (int) const
int | getKnotIdx (const TypeSet< VisID > &pckpath) const
int | getTransDragKeys (bool trans1d, int groupidx=0) const
void | handleEvents (bool yn)
void | insertKnot (int, const Coord &)
bool | isHandlingEvents () const
int | nrKnots () const
void | removeKnot (int)
NotifierAccess * | rightClicked () override
const EventInfo * | rightClickedEventInfo () const
const TypeSet< VisID > * | rightClickedPath () const override
void | setDepthRange (const Interval< float > &)
void | setDisplayTransformation (const visBase::Transformation *) override
void | setKnot (int, const Coord &)
void | setLimits (const Coord3 &start, const Coord3 &stop, const Coord3 &step)
void | setTransDragKeys (bool trans1d, int keys, int groupidx=0)
void | showAdjacentPanels (int knotidx, bool yn)
void | showAllPanels (bool yn)
void | showPlaneDraggers (bool yn, int minsizeinsteps=0)
void | updateZLimit (const Interval< float > &zborder)
Public Member Functions inherited from visBase::VisualObjectImpl
virtual void | fillPar (IOPar &) const
const Material * | getMaterial () const
Material * | getMaterial () override
bool | isRightHandSystem () const override
NotifierAccess * | materialChange ()
void | readLock ()
void | readUnLock ()
void | setLockable ()
void | setMaterial (Material *) override
void | setRightHandSystem (bool yn) override
bool | tryReadLock ()
bool | tryWriteLock ()
virtual bool | usePar (const IOPar &)
void | writeLock ()
void | writeUnLock ()
Public Member Functions inherited from visBase::VisualObject
NotifierAccess * | deSelection () override
virtual bool | getBoundingBox (Coord3 &min, Coord3 &max) const
NotifierAccess * | rightClicked () override
const EventInfo * | rightClickedEventInfo () const
const TypeSet< VisID > * | rightClickedPath () const override
bool | selectable () const override
NotifierAccess * | selection () override
virtual void | setSceneEventCatcher (EventCatcher *)
void | setSelectable (bool yn)
Public Member Functions inherited from visBase::DataObject
template<class T >
T * | addNodeState (T *ns)
void | deSelect () const
void | enableTraversal (unsigned int mask, bool yn=true)
virtual const char * | errMsg () const
SoNode * | getInventorNode ()
const SoNode * | getInventorNode () const
BufferString | getName () const override
NodeState * | getNodeState (int idx)
virtual float | getPixelDensity () const
VisID | id () const
virtual bool | isOK () const
virtual bool | isOn () const
bool | isPickable (bool actively=true) const
virtual bool | isSelected () const
bool | isTraversalEnabled (unsigned int mask) const
const OD::String & | name () const override
osg::Node * | osgNode (bool skipswitch=false)
const osg::Node * | osgNode (bool skipswitch=false) const
NodeState * | removeNodeState (NodeState *)
virtual bool | rightClickable () const
void | select () const
bool | serialize (const char *filename, bool binary=false)
void | setID (const VisID &)
void | setName (const char *) override
void | setName (const uiString &uistr)
void | setPickable (bool actively, bool passively=true)
virtual void | setPixelDensity (float dpi)
void | setUiName (const uiString &)
virtual bool | turnOn (bool yn)
uiString | uiName () const
void | updateSel () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static RefMan< RandomTrackDragger > | create ()
static const char * | getStaticClassName ()
static void | initClass ()
static const char * | sFactoryKeyword ()
Static Public Member Functions inherited from visBase::VisualObjectImpl
static const char * | sKeyIsOn ()
static const char * | sKeyMaterial ()
static const char * | sKeyMaterialID ()
Static Public Member Functions inherited from visBase::DataObject
static osgViewer::CompositeViewer * | getCommonViewer ()
static float | getDefaultPixelDensity ()
static VisID | getID (const osg::Node *)
static bool | isVisualizationThread ()
static void | requestSingleRedraw ()
static void | setCommonViewer (osgViewer::CompositeViewer *)
static void | setDefaultPixelDensity (float)
static void | setVisualizationThread (const void *)
| Call only once from initialization.
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Public Attributes
CNotifier< RandomTrackDragger, int > | motion
| knotidx>=0, panelidx<0
Notifier< RandomTrackDragger > | movefinished

## Protected Member Functions
| ~RandomTrackDragger ()
void | addPlaneDraggerCBHandler ()
bool | canShowPlaneDragger (int planeidx, bool &horoverlap) const
bool | doesKnotStickToBorder (int knotidx) const
void | doSetKnot (int, const Coord &)
void | finishCB (CallBacker *)
void | followActiveDragger (int activeidx)
int | getDragControlIdx (bool trans1d, int groupidx) const
int | getDragControlIdx (bool trans1d, int groupidx, bool docreate)
unsigned char | getOnBorderFlags (int knotidx) const
Coord3 | getPlaneBoundingBoxInSteps (int planeidx) const
void | moveCB (CallBacker *)
void | postponePanelUpdate (bool)
void | removePlaneDraggerCBHandler (int idx)
void | setPanelsPolygonOffset (bool)
void | showRotationAxis (bool yn, int planeidx=0, Coord normpickedpos=Coord::udf())
void | snapToLimits (Coord3 &pos) const
void | startCB (CallBacker *)
void | triggerRightClick (const EventInfo *eventinfo) override
void | turnPanelOn (int planeidx, bool yn)
void | updateKnotColor (int idx, bool horoverlap)
void | updatePanels ()
void | updatePlaneDraggers ()
Protected Member Functions inherited from visBase::VisualObjectImpl
| VisualObjectImpl (bool selectable)
virtual | ~VisualObjectImpl ()
int | addChild (osg::Node *)
int | childIndex (const osg::Node *) const
void | insertChild (int pos, osg::Node *)
virtual void | materialChangeCB (CallBacker *)
void | removeChild (osg::Node *)
void | setGroupNode (DataObject *)
virtual void | setGroupNode (osg::Group *)
| Must be called during construction.
Protected Member Functions inherited from visBase::VisualObject
| VisualObject (bool selectable=false)
| ~VisualObject ()
void | triggerDeSel () override
void | triggerRightClick (const EventInfo *) override
void | triggerSel () override
Protected Member Functions inherited from visBase::DataObject
| DataObject ()
| ~DataObject ()
void | doAddNodeState (NodeState *)
virtual osg::StateSet * | getStateSet ()
template<class T >
T * | setOsgNode (T *t)
| Must be called during construction.
void | updateNodemask ()
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Static Protected Member Functions
static const char * | sKeyDraggerScale ()

## Protected Attributes
ConstRefMan< visBase::Transformation > | displaytrans_
ObjectSet< DragControl > | dragcontrols_
RefObjectSet< MarkerSet > | draggermarkers_
RefObjectSet< Dragger > | draggers_
Geom::Rectangle< double > | horborder_
StepInterval< float > | limits_ [3]
osg::Switch * | panels_
int | planedraggerminsizeinsteps_ = 1
osg::Switch * | planedraggers_
ObjectSet< PlaneDragCBHandler > | planedraghandlers_
bool | postponepanelupdate_ = false
const EventInfo * | rightclickeventinfo_ = nullptr
Notifier< RandomTrackDragger > | rightclicknotifier_
osg::Switch * | rotationaxis_
BoolTypeSet | showadjacents_
bool | showallpanels_ = false
bool | showplanedraggers_ = true
Interval< float > | zborder_
Interval< float > | zrange_
Protected Attributes inherited from visBase::VisualObjectImpl
RefMan< Material > | material_
bool | righthandsystem_ = true
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Private Member Functions
| RandomTrackDragger ()
| mOD_DisableCopy (RandomTrackDragger)

## Static Private Member Functions
static visBase::DataObject * | createInternal ()

## Friends
class | PlaneDragCBHandler

## Additional Inherited Members
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Detailed Description

<>

## Constructor & Destructor Documentation

## ◆ RandomTrackDragger()

visBase::RandomTrackDragger::RandomTrackDragger | ( |  | ) |
| private

## ◆ ~RandomTrackDragger()

visBase::RandomTrackDragger::~RandomTrackDragger | ( |  | ) |
| protected

## Member Function Documentation

## ◆ addPlaneDraggerCBHandler()

void visBase::RandomTrackDragger::addPlaneDraggerCBHandler | ( |  | ) |
| protected

## ◆ areAdjacentPanelsShown()

bool visBase::RandomTrackDragger::areAdjacentPanelsShown | ( | int | knotidx | ) | const

## ◆ areAllPanelsShown()

bool visBase::RandomTrackDragger::areAllPanelsShown | ( |  | ) | const

## ◆ canShowPlaneDragger()

bool visBase::RandomTrackDragger::canShowPlaneDragger | ( | int | planeidx,
|  | bool & | horoverlap ) const
| protected

## ◆ create()

static RefMan< RandomTrackDragger > visBase::RandomTrackDragger::create | ( |  | ) |
| static

## ◆ createInternal()

static visBase::DataObject * visBase::RandomTrackDragger::createInternal | ( |  | ) |
| inline static private

## ◆ doesKnotStickToBorder()

bool visBase::RandomTrackDragger::doesKnotStickToBorder | ( | int | knotidx | ) | const
| protected

## ◆ doSetKnot()

void visBase::RandomTrackDragger::doSetKnot | ( | int | ,
|  | const Coord & | )
| protected

## ◆ finishCB()

void visBase::RandomTrackDragger::finishCB | ( | CallBacker * |  | ) |
| protected

## ◆ followActiveDragger()

void visBase::RandomTrackDragger::followActiveDragger | ( | int | activeidx | ) |
| protected

## ◆ getClassName()

const char * visBase::RandomTrackDragger::getClassName | ( |  | ) | const
| override virtual

Reimplemented from visBase::DataObject.

## ◆ getDepthRange()

Interval< float > visBase::RandomTrackDragger::getDepthRange | ( |  | ) | const

## ◆ getDisplayTransformation()

const visBase::Transformation * visBase::RandomTrackDragger::getDisplayTransformation | ( |  | ) | const
| override virtual

All positions going from the outside world to the vis should be transformed with this transform. This enables us to have different coord-systems outside OI, e.g. we can use UTM coords outside the vis without loosing precision in the vis.

Reimplemented from visBase::DataObject.

## ◆ getDragControlIdx() [1/2]

int visBase::RandomTrackDragger::getDragControlIdx | ( | bool | trans1d,
|  | int | groupidx ) const
| protected

## ◆ getDragControlIdx() [2/2]

int visBase::RandomTrackDragger::getDragControlIdx | ( | bool | trans1d,
|  | int | groupidx,
|  | bool | docreate )
| protected

## ◆ getKnot()

Coord visBase::RandomTrackDragger::getKnot | ( | int |  | ) | const

## ◆ getKnotIdx()

int visBase::RandomTrackDragger::getKnotIdx | ( | const TypeSet< VisID > & | pckpath | ) | const

## ◆ getOnBorderFlags()

unsigned char visBase::RandomTrackDragger::getOnBorderFlags | ( | int | knotidx | ) | const
| protected

## ◆ getPlaneBoundingBoxInSteps()

Coord3 visBase::RandomTrackDragger::getPlaneBoundingBoxInSteps | ( | int | planeidx | ) | const
| protected

## ◆ getStaticClassName()

static const char * visBase::RandomTrackDragger::getStaticClassName | ( |  | ) |
| static

## ◆ getTransDragKeys()

int visBase::RandomTrackDragger::getTransDragKeys | ( | bool | trans1d,
|  | int | groupidx = 0 ) const

## ◆ handleEvents()

void visBase::RandomTrackDragger::handleEvents | ( | bool | yn | ) |

## ◆ initClass()

static void visBase::RandomTrackDragger::initClass | ( |  | ) |
| static

## ◆ insertKnot()

void visBase::RandomTrackDragger::insertKnot | ( | int | ,
|  | const Coord & | )

## ◆ isHandlingEvents()

bool visBase::RandomTrackDragger::isHandlingEvents | ( |  | ) | const

## ◆ mOD_DisableCopy()

visBase::RandomTrackDragger::mOD_DisableCopy | ( | RandomTrackDragger |  | ) |
| private

## ◆ moveCB()

void visBase::RandomTrackDragger::moveCB | ( | CallBacker * |  | ) |
| protected

## ◆ nrKnots()

int visBase::RandomTrackDragger::nrKnots | ( |  | ) | const

## ◆ postponePanelUpdate()

void visBase::RandomTrackDragger::postponePanelUpdate | ( | bool |  | ) |
| protected

## ◆ removeKnot()

void visBase::RandomTrackDragger::removeKnot | ( | int |  | ) |

## ◆ removePlaneDraggerCBHandler()

void visBase::RandomTrackDragger::removePlaneDraggerCBHandler | ( | int | idx | ) |
| protected

## ◆ rightClicked()

NotifierAccess * visBase::RandomTrackDragger::rightClicked | ( |  | ) |
| inline override virtual

Reimplemented from visBase::DataObject.

## ◆ rightClickedEventInfo()

const EventInfo * visBase::RandomTrackDragger::rightClickedEventInfo | ( |  | ) | const

## ◆ rightClickedPath()

const TypeSet< VisID > * visBase::RandomTrackDragger::rightClickedPath | ( |  | ) | const
| override virtual

Reimplemented from visBase::DataObject.

## ◆ setDepthRange()

void visBase::RandomTrackDragger::setDepthRange | ( | const Interval< float > & |  | ) |

## ◆ setDisplayTransformation()

void visBase::RandomTrackDragger::setDisplayTransformation | ( | const visBase::Transformation * |  | ) |
| override virtual

All positions going from the outside world to the vis should be transformed with this transform. This enables us to have different coord-systems outside OI, e.g. we can use UTM coords outside the vis without loosing precision in the vis.

Reimplemented from visBase::DataObject.

## ◆ setKnot()

void visBase::RandomTrackDragger::setKnot | ( | int | ,
|  | const Coord & | )

## ◆ setLimits()

void visBase::RandomTrackDragger::setLimits | ( | const Coord3 & | start,
|  | const Coord3 & | stop,
|  | const Coord3 & | step )

## ◆ setPanelsPolygonOffset()

void visBase::RandomTrackDragger::setPanelsPolygonOffset | ( | bool |  | ) |
| protected

## ◆ setTransDragKeys()

void visBase::RandomTrackDragger::setTransDragKeys | ( | bool | trans1d,
|  | int | keys,
|  | int | groupidx = 0 )

## ◆ sFactoryKeyword()

static const char * visBase::RandomTrackDragger::sFactoryKeyword | ( |  | ) |
| static

## ◆ showAdjacentPanels()

void visBase::RandomTrackDragger::showAdjacentPanels | ( | int | knotidx,
|  | bool | yn )

## ◆ showAllPanels()

void visBase::RandomTrackDragger::showAllPanels | ( | bool | yn | ) |

## ◆ showPlaneDraggers()

void visBase::RandomTrackDragger::showPlaneDraggers | ( | bool | yn,
|  | int | minsizeinsteps = 0 )

## ◆ showRotationAxis()

void visBase::RandomTrackDragger::showRotationAxis | ( | bool | yn,
|  | int | planeidx = 0,
|  | Coord | normpickedpos = Coord::udf() )
| protected

## ◆ sKeyDraggerScale()

static const char * visBase::RandomTrackDragger::sKeyDraggerScale | ( |  | ) |
| inline static protected

## ◆ snapToLimits()

void visBase::RandomTrackDragger::snapToLimits | ( | Coord3 & | pos | ) | const
| protected

## ◆ startCB()

void visBase::RandomTrackDragger::startCB | ( | CallBacker * |  | ) |
| protected

## ◆ triggerRightClick()

void visBase::RandomTrackDragger::triggerRightClick | ( | const EventInfo * | eventinfo | ) |
| override protected virtual

Reimplemented from visBase::DataObject.

## ◆ turnPanelOn()

void visBase::RandomTrackDragger::turnPanelOn | ( | int | planeidx,
|  | bool | yn )
| protected

## ◆ updateKnotColor()

void visBase::RandomTrackDragger::updateKnotColor | ( | int | idx,
|  | bool | horoverlap )
| protected

## ◆ updatePanels()

void visBase::RandomTrackDragger::updatePanels | ( |  | ) |
| protected

## ◆ updatePlaneDraggers()

void visBase::RandomTrackDragger::updatePlaneDraggers | ( |  | ) |
| protected

## ◆ updateZLimit()

void visBase::RandomTrackDragger::updateZLimit | ( | const Interval< float > & | zborder | ) |

## Friends And Related Symbol Documentation

## ◆ PlaneDragCBHandler

friend class PlaneDragCBHandler
| friend

## Member Data Documentation

## ◆ displaytrans_

ConstRefMan< visBase::Transformation > visBase::RandomTrackDragger::displaytrans_
| protected

## ◆ dragcontrols_

ObjectSet<DragControl> visBase::RandomTrackDragger::dragcontrols_
| protected

## ◆ draggermarkers_

RefObjectSet<MarkerSet> visBase::RandomTrackDragger::draggermarkers_
| protected

## ◆ draggers_

RefObjectSet<Dragger> visBase::RandomTrackDragger::draggers_
| protected

## ◆ horborder_

Geom::Rectangle<double> visBase::RandomTrackDragger::horborder_
| protected

## ◆ limits_

StepInterval<float> visBase::RandomTrackDragger::limits_[3]
| protected

## ◆ motion

CNotifier<RandomTrackDragger,int> visBase::RandomTrackDragger::motion

knotidx>=0, panelidx<0

## ◆ movefinished

Notifier<RandomTrackDragger> visBase::RandomTrackDragger::movefinished

## ◆ panels_

osg::Switch* visBase::RandomTrackDragger::panels_
| protected

## ◆ planedraggerminsizeinsteps_

int visBase::RandomTrackDragger::planedraggerminsizeinsteps_ = 1
| protected

## ◆ planedraggers_

osg::Switch* visBase::RandomTrackDragger::planedraggers_
| protected

## ◆ planedraghandlers_

ObjectSet<PlaneDragCBHandler> visBase::RandomTrackDragger::planedraghandlers_
| protected

## ◆ postponepanelupdate_

bool visBase::RandomTrackDragger::postponepanelupdate_ = false
| protected

## ◆ rightclickeventinfo_

const EventInfo* visBase::RandomTrackDragger::rightclickeventinfo_ = nullptr
| protected

## ◆ rightclicknotifier_

Notifier<RandomTrackDragger> visBase::RandomTrackDragger::rightclicknotifier_
| protected

## ◆ rotationaxis_

osg::Switch* visBase::RandomTrackDragger::rotationaxis_
| protected

## ◆ showadjacents_

BoolTypeSet visBase::RandomTrackDragger::showadjacents_
| protected

## ◆ showallpanels_

bool visBase::RandomTrackDragger::showallpanels_ = false
| protected

## ◆ showplanedraggers_

bool visBase::RandomTrackDragger::showplanedraggers_ = true
| protected

## ◆ zborder_

Interval<float> visBase::RandomTrackDragger::zborder_
| protected

## ◆ zrange_

Interval<float> visBase::RandomTrackDragger::zrange_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025